;  ***********************************
;        BIN LAND
;        by: Jirka 
; ***************************************



#include "asm86.h"         
#include "ti86asm.inc"


_user_int_ram EQU $d2fd

#define PAGE1_BPL1         $3C
#define PAGE1_BPL2         $37


.org _asm_exec_ram        

;****for ASE     **''*
;    nop	
;    jp first 
;    .dw $0000	
;    .dw title    
;***

VideoDraw = $f300				; [1024] virtual screen or video ram
GrayDraw1 = $fc00				; [1024] dark grayscale plane
GrayDraw2 = $f700				; [1024] light grayscale plane

xcrd         =$8000             
ycrd         =$8001
sailo        =$8002
count        =$8003 
blockx       =$8004
blocky       =$8005
rivicnt      =$8006
bxcrd        =$8007
bycrd        =$8008
;done         =$8009
level        =$8010
;blockcount   =$8011
;mtime        =$8012


first:

    call BUSY_OFF          
    call _clrScrn           
 

; TITLE Picture  *******    
    LD DE,$FC00
	ld BC,1024	
	LD HL,TITLEPIC	
	ldir			
;************** 

	ld hl,1
	ld (level),hl

menu:
	call GET_KEY
	cp K_ENTER
	jr z,alku
	cp K_SECOND
	jr z,alku
	cp K_EXIT
	jp z,EXIT	
	cp K_UP
	call z,menu_inc
	cp K_DOWN
	call z,menu_dec
		
	ld hl,$0806	
    ld (_penRow),hl		
	ld (_curRow),hl
	ld hl,(level)
	call DispHL

		jr menu   

menu_inc:
	ld a,(level)
	cp 20
	ret z
	inc a
	ld (level),a
		ret

menu_dec:
	ld a,(level)
	cp 1
	ret z
	dec a
	ld (level),a
		ret
     
alku:
	call CloseGray
	jp CHS_LEV
point0:
    call _clrLCD
    ld a,0
    ld (rivicnt),a
    ld (blockx),a
    ld (blocky),a
    ;ld (blockcount),a
    
    ;ld (time),a
    ;ld (mtime),a      
   
    call PLACE	    

	set 3,(iy+5)
	ld hl,$0000
	ld (_curRow),hl	
	ld hl,invert_text0
	call _puts

	ld hl,$0007	
	ld (_curRow),hl	
	ld hl,invert_text1
	call _puts
    res 3,(iy+5)
	

	ld hl,$0503
    ld (_curRow),hl
	ld hl,leveltext
	call _puts

	ld hl,$0B03
	ld (_penCol),a   
	ld hl,(level)
	call DispHL

    call Pause   

    call CloseGray
	call OpenGray
   
    call DRAWLEVEL


ASK_FOR_KEY:

    call DRAW                 
    call DRAWEXIT

    call GET_KEY           	
    cp K_EXIT             
    jp z,EXIT                     
    cp K_RIGHT
    jp z,RIGHT
    cp K_LEFT
    jp z,LEFT
    cp K_DOWN
    jp z,DOWN
    cp K_UP
    jp z,UP
    cp K_PLUS
    jp z,SKIP_LEVEL
	cp K_MINUS
	jp z,PREV_LEVEL  
    cp K_CLEAR
    jp z,alku
    cp K_F1
    jp z,Acon
    cp K_F2
    jp z,Scon   


	jp CHK_VERKOT

 
    jp ASK_FOR_KEY
    


RIGHT:
	        
    ld a,(xcrd)   
    inc a    
    cp 16
    jp z,R2    

    ld de,LEV
    ld a,(ycrd)
    ld b,a
multipr:
    add a,15
  djnz multipr
    ld c,a
    ld a,(xcrd)
    add a,c    
    inc a
    ld b,a   
multipr2:
    inc de
  djnz multipr2
    ld a,(de)    
    cp 1
    jp z,R2           

    call ERASE
    ld a,(xcrd)
    inc a
    ld (xcrd),a    
    ;call DRAW
R2:    
    ld a,(bxcrd)   
    dec a    
    cp -1
    jp z,ASK_FOR_KEY     

    ld de,LEV
    ld a,(bycrd)
    ld b,a
bmultipr:
    add a,15
  djnz bmultipr
    ld c,a
    ld a,(bxcrd)
    add a,c    
    dec a
    ld b,a   
bmultipr2:
    inc de
  djnz bmultipr2
    ld a,(de)    
    cp 1
    jp z,ASK_FOR_KEY
 
    call ERASE
    ld a,(bxcrd)
    dec a
    ld (bxcrd),a    
    ;call DRAW              

    jp CHECK_GOAL 

    
    ;jp ASK_FOR_KEY


LEFT:
	                  
 
    ld a,(xcrd)   
    dec a    
    cp -1
    jp z,Lkaksi

    ld de,LEV
    ld a,(ycrd)
    ld b,a
multipl:
    add a,15
  djnz multipl
    ld c,a
    ld a,(xcrd)
    add a,c    
    dec a
    ld b,a   
multipl2:
    inc de
  djnz multipl2
    ld a,(de)     
    cp 1
    jp z,Lkaksi     

    call ERASE
    ld a,(xcrd)    
    dec a
    ld (xcrd),a
    ;call DRAW
Lkaksi:      
    ld a,(bxcrd)   
    inc a    
    cp 16
    jp z,ASK_FOR_KEY    

    ld de,LEV
    ld a,(bycrd)
    ld b,a
bmultipl:
    add a,15
  djnz bmultipl
    ld c,a
    ld a,(bxcrd)
    add a,c    
    inc a
    ld b,a   
bmultipl2:
    inc de
  djnz bmultipl2
    ld a,(de)     
    cp 1
    jp z,ASK_FOR_KEY
 
    call ERASE
    ld a,(bxcrd)
    inc a
    ld (bxcrd),a    
    ;call DRAW     

    jp CHECK_GOAL 
      
    ;jp ASK_FOR_KEY
    

DOWN:
	
    
    ld a,(ycrd)   
    inc a    
    cp 8
    jp z,D2
 
    ld de,LEV
    ld a,(ycrd)
    ld b,a
multipd:
    add a,15
  djnz multipd
    ld c,a
    ld a,(xcrd)
    add a,c    
    add a,16
    ld b,a   
multipd2:
    inc de
  djnz multipd2
    ld a,(de)     
    cp 1
    jp z,D2          

    call ERASE
    ld a,(ycrd)
    inc a
    ld (ycrd),a   
    ;call DRAW

D2:    
    ld a,(bycrd)   
    inc a    
    cp 8
    jp z,ASK_FOR_KEY   

    ld de,LEV
    ld a,(bycrd)
    ld b,a
bmultipd:
    add a,15
  djnz bmultipd
    ld c,a
    ld a,(bxcrd)
    add a,c    
    add a,16
    ld b,a   
bmultipd2:
    inc de
  djnz bmultipd2
    ld a,(de)     
    cp 1
    jp z,ASK_FOR_KEY
 
    call ERASE
    ld a,(bycrd)
    inc a
    ld (bycrd),a    
    call DRAW           
   
    jp ASK_FOR_KEY

UP:  
	
    ld a,(ycrd)   
    dec a    
    cp -1
    jp z,U2   
 
    ld de,LEV
    ld a,(ycrd)
    ld b,a
multipu:
    add a,15
  djnz multipu
    ld c,a
    ld a,(xcrd)
    add a,c    
    sub 16
    ld b,a   
multipu2:
    inc de
  djnz multipu2
    ld a,(de)    
    cp 1
    jp z,U2     
    
    call ERASE
    ld a,(ycrd)
    dec a
    ld (ycrd),a    
    ;call DRAW

U2:    
    ld a,(bycrd)   
    dec a    
    cp -1
    jp z,ASK_FOR_KEY      
 
    ld de,LEV
    ld a,(bycrd)
    ld b,a
bmultipu:
    add a,15
  djnz bmultipu
    ld c,a
    ld a,(bxcrd)
    add a,c    
    sub 16
    ld b,a   
bmultipu2:
    inc de
  djnz bmultipu2
    ld a,(de)    
    cp 1
    jp z,ASK_FOR_KEY
 
    call ERASE
    ld a,(bycrd)
    dec a
    ld (bycrd),a    
    ;call DRAW           
    
    jp ASK_FOR_KEY


ERASE:
    ld hl,CLRPIC
    ld a,(xcrd)
    call kerto
    ld e,a
    ld a,(ycrd)
    call kerto 
    ld c,a
    ld b,e
    call GraySprite

    ld hl,CLRPIC
    ld a,(bxcrd)
    call kerto
    ld e,a
    ld a,(bycrd)
    call kerto
    ld c,a
    ld b,e
    call GraySprite   

    	ret

DRAW:	
    ld hl,PIC1
    ld a,(xcrd)
    call kerto
    ld e,a
    ld a,(ycrd)
    call kerto
    ld c,a
    ld b,e
    call GraySprite	
    ld hl,PIC2
    ld a,(bxcrd)
    call kerto
    ld e,a
    ld a,(bycrd)
    call kerto	
    ld c,a
    ld b,e
    call GraySprite
    	ret


kerto:
	ld b,a
	ld a,0
kertovali:
	add a,8
       djnz kertovali
      ret


; DrawLevel
;***********************************************************

DRAWLEVEL:        
        
    ld a,0             
    ld (count),a          ;count=0          
    ld (rivicnt),a 
   
DRAWvali:             
    ld de,LEV               ;de osoitaa kentaan    
    ld a,(count)                        
    ld b,a  
looppi:        
    inc de     
  djnz looppi
    
    ld a,(de)               
                    ;onko kohdassa palikkaa vai ei
    cp 0                  ;if a=c    
    jr z,BLOCKoff
    cp 1
    jr z,BLOCKon     
    cp 2
    jr z,NETon   
  
DRAWvali2:    
    ld a,(count)         ;joko count koko kentta
    inc a
    ld (count),a   
    cp 128
    ret z       
    ld a,(rivicnt)           ;joko vaihdetaan rivia    
    cp 15
    call z,addrivi
    ld a,(rivicnt)
    inc a
    ld (rivicnt),a    

    jp DRAWvali
    
BLOCKoff:                 ;ala piirra palikkaa
    jp DRAWvali2

BLOCKon:  
    ld a,(rivicnt)        ;palikan piirto
    ld b,a
    ld a,0
xkertaa8:
    add a,8
   djnz xkertaa8
    ld (blockx),a    

    ld a,(blocky)
    ld b,a
    ld a,0
kertaa8:
    add a,8
   djnz kertaa8                        
    
    ld c,a
    ld a,(blockx)
    ld b,a

    ld hl,BOXPIC
    call GraySprite
    jp DRAWvali2

NETon:
    ld a,(rivicnt)        ;kuolema palikan piirto
    call kerto
    ld e,a
    ld a,(blocky)
    call kerto
    ld c,a
    ld b,e
    ld hl,NETPIC
    call GraySprite
    jp DRAWvali2


addrivi:                   ;seuraava rivi ja rivi rivicnt=0 
    ld a,(blocky)
    inc a
    ld (blocky),a
    ld a,-1  
    ld (rivicnt),a
    	ret

DRAWEXIT:
    ld c,0
    ld a,7
    call kerto
    ld b,a
    ld hl,EXITPIC
    call GraySprite
    ret


;**************************************************************

;**CHOOSE_LEVEL
CHS_LEV:
   
   ld a,(level)

	cp 0
	jp z,SKIP_LEVEL
	ld hl,LEV1	
	cp 1
	jp z,endnext
	ld hl,LEV2
	cp 2
	jp z,endnext
    ld hl,LEV3
	cp 3
	jp z,endnext
	ld hl,LEV4
	cp 4
	jp z,endnext
	ld hl,LEV5
	cp 5
	jp z,endnext
	ld hl,LEV6
	cp 6
	jp z,endnext
	ld hl,LEV7
	cp 7
	jp z,endnext
	ld hl,LEV8
	cp 8
	jp z,endnext
	ld hl,LEV9
	cp 9
	jp z,endnext
	ld hl,LEV10
	cp 10
	jp z,endnext
	ld hl,LEV11
	cp 11
	jp z,endnext
	ld hl,LEV12
	cp 12
	jp z,endnext
	ld hl,LEV13
	cp 13
	jp z,endnext
	ld hl,LEV14
	cp 14
	jp z,endnext
	ld hl,LEV15
	cp 15
	jp z,endnext
	ld hl,LEV16
	cp 16
	jp z,endnext
	ld hl,LEV17
	cp 17
	jp z,endnext
	ld hl,LEV18
	cp 18
	jp z,endnext
	ld hl,LEV19
	cp 19
	jp z,endnext
	ld hl,LEV20
	cp 20
	jp z,endnext	
	cp 21
	jp z,COMPLETE

	


  ;  cp 1 
  ;  jp z,loadl1   
  ;  cp 2 
  ;  jp z,loadl2   
  ;  cp 3 
  ;  jp z,loadl3   
  ;  cp 4
  ;  jp z,loadl4   
  ;  cp 5
  ;  jp z,loadl5   
  ;  cp 6
  ;  jp z,loadl6   
  ;  cp 7
  ;  jp z,loadl7   
  ;  cp 8
  ;  jp z,loadl8   
  ;  cp 9
  ;  jp z,loadl9   
  ;  cp 10
  ;  jp z,loadl10   
  ;  cp 11
  ;  jp z,loadl11   
  ;  cp 12
  ;  jp z,loadl12
;	cp 13
;	jp z,loadl13
;	cp 14
 ;	jp z,loadl14
;	cp 15
;	jp z,loadl15
	;cp 16
	;jp z,COMPLETE



;loadl1:
;    ld hl,LEV1
;    jp endnext    
;loadl2:
;    ld hl,LEV2    
;    jp endnext
;loadl3:
;    ld hl,LEV3    
;    jp endnext
;loadl4:
;    ld hl,LEV4
;    jp endnext      
;loadl5:
;    ld hl,LEV5
;    jp endnext    
;loadl6:
;    ld hl,LEV6    
;    jp endnext
;loadl7:
;    ld hl,LEV7
;    jp endnext    
;loadl8:
;    ld hl,LEV8    
;    jp endnext
;loadl9:
;    ld hl,LEV9
;    jp endnext
;loadl10:
;    ld hl,LEV10
;    jp endnext
;loadl11:
;    ld hl,LEV11
;    jp endnext
;loadl12:
;	ld hl,LEV12
;	jp endnext
;loadl13:
	;ld hl,LEV13
	;jp endnext
;loadl14:
	;ld hl,LEV14
	;jp endnext
;loadl15:	
;    call COMPLETE




endnext:
	ld de,LEV   
    ld bc,128
	ldir
		jp point0



;**





; ONKO MAALISSA     ***************************

CHECK_GOAL:
    ld a,(xcrd)              ;ovatko samassa kohdassa
    ld c,a
    ld a,(bxcrd)    
    cp c            
    jp nz,endcheck           ;jos eivat pois
    

    ld a,(xcrd)    
    cp 7
    jp nz,endcheck    ;onko x 7 jos ei niin pois

    ld a,(ycrd)    
    cp 0
    jp nz,endcheck        ;onko y 0 jos ei niin pois

    ld a,(bxcrd)  
    cp 7
    jp nz,endcheck
  
    ld a,(bycrd)       
    cp 0
    jp z,NEXT_LEVEL   

    



endcheck:
    jp ASK_FOR_KEY

;*******************************************




; NEXT LEVEL**************************************


NEXT_LEVEL:
	

	call CloseGray

    ld hl,$0402
    ld (_curRow),hl      
    ld hl,nexttext   
	call _puts
    call Pause   

   ld a,(level)
   inc a
   ld (level),a
   
   jp alku
  

;*********************************************************

;**********PREV ja SKIP LEVEL ******************
PREV_LEVEL:
	call CloseGray
	ld a,(level)
	dec a
	ld (level),a

		jp alku

	
SKIP_LEVEL:
	call CloseGray
	ld a,(level)
	inc a
	ld (level),a

		jp alku


;******************************************************

;****PLACE MEN******
PLACE:
   ld a,6
   ld (xcrd),a
   ld a,8
   ld (bxcrd),a
   ld a,7
   ld (ycrd),a
   ld (bycrd),a
 		ret

;******


;**********GAME COMPLETE**********************

COMPLETE:
    
    call _clrLCD
    ld hl,$0202
    ld (_curRow),hl      
    ld hl,lapitext
    call _puts
    call Pause
    jp EXIT
  

;**********************************************





;*****TARKISTA VERKOT********************

CHK_VERKOT:
    ld de,LEV
    ld a,(ycrd)
    ld b,a
verkotmultip:
    add a,15
  djnz verkotmultip
    ld c,a
    ld a,(xcrd)
    add a,c       
    ld b,a   
verkotmultip2:
    inc de
  djnz verkotmultip2
    ld a,(de)    
    cp 2
    jp z,KUOLEMA        

    ld de,LEV
    ld a,(bycrd)
    ld b,a
bverkotmultip:
    add a,15
  djnz bverkotmultip
    ld c,a
    ld a,(bxcrd)
    add a,c       
    ld b,a   
bverkotmultip2:
    inc de
  djnz bverkotmultip2
    ld a,(de)     
    cp 2
    jp z,KUOLEMA          
 
   	jp ASK_FOR_KEY

;********************************************

;******DEATH**********************************

KUOLEMA:
	
    
    call _clrLCD
    call CloseGray

    ld hl,$0502
    ld (_curRow),hl      
    ld hl,deathtext
    call _puts
       
    call Pause
    call _clrLCD

    jp alku
    ;jp ASK_FOR_KEY


   ret

;*********************************************

;*****TARKISTA AIKA*****************************

;CHK_TIME:
;    ld a,(time)                ;time=time+1
;    inc a
;    ld (time),a
;    ld c,255                    ;if time==255
;    cp c  
;    jp z,aikam                  ;then jp aikam
;    ret                         ;else ret
          
 
;aikam:
;    ld a,(mtime)               ;timem=timem+1
;    inc a
;    ld (mtime),a
;    ld a,0                     ;time=0
;    ld (time),a   
;    ld c,2                    ;if timem==255
;    cp c
;    jp z,KUOLEMA                ;then jp KUOLEMA
;    ret                         ;else ret



;*************************************



;TEKSTI:
;    ld hl,$0202
;    ld (_curRow),hl      
;    ld hl,readytext
;    call _puts
;    ret
;
;TEKSTI2:
;    ld hl,$0007
;    ld (_curRow),hl      
;    ld hl,text2
;    call _puts
;    ret



     
LEV:
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,


LEV1: 
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 1,0,1,1,0,1,1,1,0,1,1,1,0,1,1,1,
.db 1,1,0,1,0,1,0,1,1,1,0,1,0,1,0,1,
.db 1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,
.db 1,0,1,1,1,1,0,1,0,1,1,1,1,1,0,1,
.db 1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,
.db 1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0  

LEV2: 
.db 0,2,0,0,0,0,0,0,0,0,0,1,1,1,0,1,
.db 1,1,0,1,1,1,1,1,1,1,0,0,0,1,0,1,
.db 1,0,0,1,0,1,0,1,0,0,0,0,0,1,0,1,
.db 0,0,1,1,0,0,0,1,0,1,1,1,0,0,0,1,
.db 0,1,1,1,0,1,1,1,0,1,0,1,0,1,1,1,
.db 0,0,0,0,0,0,1,1,0,0,0,1,0,0,0,1,
.db 1,1,1,0,1,0,2,1,1,1,0,1,1,1,1,1,
.db 0,0,0,0,0,0,0,1,0,0,0,0,2,0,0,0

LEV3: 
.db 2,2,2,2,2,2,0,0,0,2,2,2,2,2,2,2,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
.db 2,2,0,2,2,2,2,1,0,2,2,2,2,0,2,2,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
.db 2,2,0,2,0,2,2,1,2,2,2,2,0,2,2,2,
.db 2,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,
.db 2,0,2,2,2,2,2,1,2,2,2,2,2,2,0,2,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0

LEV4
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
.db 0,1,0,1,0,1,2,1,0,0,0,0,0,1,0,0,
.db 0,0,0,0,0,1,0,1,0,0,1,0,1,1,0,1,
.db 1,1,1,1,0,1,0,1,0,0,1,0,0,0,0,2,
.db 0,0,2,0,0,0,0,1,1,1,1,1,1,0,1,0,
.db 1,0,1,0,1,1,1,1,0,1,0,2,1,0,1,1,
.db 1,1,1,0,0,0,0,1,0,0,0,0,0,0,2,0

LEV5:
.db 1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,
.db 0,0,0,0,0,0,0,2,0,0,0,0,0,0,2,2,
.db 0,2,1,1,1,1,1,1,1,1,1,0,1,1,1,1,
.db 0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,
.db 1,1,1,1,2,0,2,1,1,1,2,1,1,1,0,1,
.db 0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,
.db 1,0,1,1,1,2,1,1,1,0,2,1,1,2,1,1
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,

LEV6: 
.db 0,1,2,1,2,1,0,0,0,0,1,2,1,2,1,0,
.db 2,0,0,0,0,0,0,1,2,0,0,0,0,0,0,0,
.db 0,1,1,1,1,1,0,1,0,1,1,1,1,1,1,0,
.db 0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,
.db 0,1,1,1,1,1,2,1,0,1,1,1,1,1,1,0,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
.db 0,1,1,1,1,1,0,1,0,1,1,1,1,1,1,0,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0

LEV7: 
.db 0,0,0,0,2,0,0,0,0,0,0,0,0,0,1,1,
.db 0,0,0,1,1,0,2,1,1,1,0,0,0,0,1,1,
.db 0,0,0,1,2,0,0,1,1,1,0,1,1,0,0,2,
.db 1,1,0,0,0,0,2,2,0,0,0,2,1,1,0,0,
.db 1,1,0,2,0,0,0,1,1,1,0,1,1,1,0,2,
.db 0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,
.db 2,0,1,1,0,1,1,1,1,1,0,2,0,1,1,0,
.db 2,0,1,2,0,0,0,2,0,0,0,0,0,1,1,0


LEV8: 
.db 2,1,2,1,2,1,0,0,0,2,0,2,0,0,2,0,
.db 0,0,0,0,0,0,0,1,0,0,0,0,2,0,0,0,
.db 1,0,1,1,0,1,1,1,0,2,0,0,0,0,2,0,
.db 0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0,
.db 0,1,0,1,1,0,1,1,0,0,0,2,0,0,0,0,
.db 0,1,0,0,1,0,0,1,2,0,0,0,0,0,2,0,
.db 0,1,1,0,1,1,2,1,0,2,0,2,0,0,0,0,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0

LEV9: 
.db 2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 1,0,2,1,1,1,0,2,1,1,1,1,1,1,1,0,
.db 0,0,2,1,1,1,0,2,0,0,0,0,0,0,0,0,
.db 0,2,1,1,1,1,2,1,0,1,1,1,1,1,0,1,
.db 0,2,0,0,0,1,0,1,0,0,0,0,0,1,0,1,
.db 0,2,0,1,0,1,0,1,1,1,1,1,0,1,0,1,
.db 0,2,0,1,0,1,0,1,0,0,0,0,0,0,1,1,
.db 0,0,0,1,0,0,0,1,0,1,1,1,1,1,0,0  
  
LEV10: 
.db 0,0,0,0,0,0,0,0,0,1,2,1,0,0,0,0,
.db 1,0,1,1,2,0,1,1,0,0,0,0,0,2,1,0,
.db 1,0,0,2,0,0,0,1,0,1,1,0,1,0,1,0,
.db 0,1,1,0,1,0,1,1,1,0,0,0,1,0,0,0,
.db 0,0,0,0,1,0,1,1,0,1,1,0,0,2,1,0,
.db 1,0,1,0,0,0,2,1,0,0,0,0,1,0,0,0,
.db 1,0,1,0,1,1,0,1,0,1,1,2,1,0,1,1,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0

LEV11: 
.db 0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,
.db 1,1,1,2,0,2,2,1,2,2,0,2,1,1,1,1,
.db 2,0,0,0,0,0,1,2,1,1,0,0,0,0,0,2,
.db 2,2,1,2,0,2,2,1,2,2,0,2,0,0,2,1,
.db 2,0,1,0,0,0,1,2,1,0,0,2,0,0,0,1,
.db 1,0,0,0,1,0,2,1,2,0,1,1,1,0,0,0,
.db 1,1,0,2,2,2,1,2,1,0,1,2,0,0,1,0,
.db 1,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1

LEV12: 
.db 0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,
.db 1,1,1,0,2,2,0,2,2,0,0,0,1,1,0,1,
.db 0,0,1,0,0,0,0,2,1,0,1,0,0,2,0,1,
.db 1,1,1,0,1,1,0,2,0,2,1,0,1,1,0,1,
.db 0,0,0,0,0,0,0,2,0,0,1,0,0,0,0,0,
.db 2,1,1,0,2,1,1,2,1,0,1,1,1,1,0,1,
.db 0,0,1,0,0,0,1,2,1,0,1,0,0,0,0,1,
.db 1,1,1,1,2,0,0,2,0,0,0,0,1,1,0,1

LEV13:
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
.db 2,0,2,1,2,0,2,1,2,0,2,1,2,0,2,1,
.db 2,0,1,2,2,0,0,2,0,0,0,0,0,0,0,0,
.db 2,0,0,0,0,0,0,1,0,2,2,1,1,1,2,0,
.db 1,1,1,0,1,1,2,2,0,0,0,1,0,0,0,0,
.db 2,0,1,0,1,1,0,1,0,2,0,0,0,1,0,2,
.db 2,0,0,0,0,0,0,1,1,1,0,2,0,1,0,1,
.db 1,2,0,2,1,1,0,1,0,0,0,0,0,1,0,1,

LEV14: 
.db 0,1,2,1,0,1,0,0,0,1,0,1,0,1,0,1,
.db 0,0,0,0,0,0,0,1,0,2,0,0,0,0,0,0,
.db 0,1,2,1,0,1,0,1,0,1,0,1,2,1,0,1,
.db 0,0,0,0,2,0,2,1,0,0,0,0,0,0,0,0,
.db 2,1,0,1,0,1,0,1,0,1,2,1,0,1,2,1,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
.db 0,1,0,1,2,1,0,1,2,1,0,1,0,1,2,1,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0

LEV15: 
.db 1,1,1,1,1,2,0,0,0,2,1,1,1,1,1,1,
.db 2,0,0,0,0,2,0,2,0,2,0,0,0,0,0,2,
.db 0,0,0,2,0,2,0,0,0,2,0,0,0,0,0,0,
.db 0,0,0,0,0,2,2,0,2,2,1,0,1,1,2,0,
.db 1,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,
.db 1,0,1,0,0,0,0,1,0,2,1,1,1,0,2,1,
.db 1,0,1,0,2,0,1,1,0,0,0,0,0,0,0,1,
.db 1,1,1,0,2,0,0,1,0,2,2,0,2,2,0,1  

LEV16: 
.db 0,1,0,1,0,2,0,0,0,2,0,0,0,0,0,1,
.db 0,0,0,1,0,0,0,2,0,1,0,1,2,1,0,1,
.db 0,1,0,1,0,2,2,1,0,1,0,1,0,1,0,1,
.db 0,1,0,0,0,1,0,2,0,0,0,1,0,1,0,1,
.db 0,1,0,1,0,2,0,1,0,1,2,1,0,1,0,1,
.db 0,0,0,1,0,0,0,1,0,1,0,0,0,1,0,1,
.db 0,1,0,1,0,2,0,1,2,1,0,1,0,1,0,1,
.db 0,1,0,1,0,1,0,1,0,0,0,1,0,0,0,1

LEV17: 
.db 0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,
.db 0,1,0,0,0,2,1,1,1,2,1,1,1,2,1,0,
.db 1,2,1,1,0,0,0,0,1,0,1,2,0,0,1,0,
.db 2,0,0,0,0,2,1,1,1,0,1,1,1,0,0,0,
.db 1,0,1,0,1,0,1,2,0,0,0,0,0,0,1,1,
.db 1,0,1,0,1,0,1,1,0,1,0,1,0,0,0,1,
.db 1,0,1,1,1,2,0,1,0,1,1,1,0,1,1,1,
.db 2,0,0,0,0,0,0,1,0,2,0,0,0,0,0,0

LEV18: 
.db 0,0,1,1,1,0,0,0,0,2,1,1,1,1,0,0,
.db 1,0,0,1,2,0,2,2,0,2,1,1,1,2,0,0,
.db 1,1,0,0,0,0,1,2,0,0,0,1,0,0,0,2,
.db 1,1,1,0,2,1,1,2,0,2,0,2,0,0,0,1,
.db 1,1,0,0,0,0,1,2,0,1,0,0,0,2,1,1,
.db 1,0,0,1,0,0,0,2,1,1,1,0,0,1,1,1,
.db 2,0,1,1,1,0,0,2,1,1,1,1,0,0,1,1,
.db 2,1,1,1,1,1,0,2,0,0,0,0,0,0,0,1

LEV19: 
.db 0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,
.db 0,1,1,1,0,1,0,1,2,2,2,2,2,2,2,0,
.db 0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,
.db 0,1,1,1,2,1,0,1,0,2,2,2,2,2,2,2,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,2,0,0,
.db 0,1,1,0,1,1,2,1,1,2,1,1,0,1,1,0,
.db 0,1,1,0,1,1,0,1,1,0,1,1,0,1,1,0,
.db 0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0
                                            
LEV20: 
.db 0,0,2,0,0,0,0,0,0,0,0,0,2,0,0,0,
.db 2,2,2,0,2,2,2,0,2,2,2,0,2,2,2,2,
.db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
.db 1,2,0,2,1,1,1,1,1,1,1,1,0,2,0,1,
.db 1,0,0,2,0,2,0,1,0,2,0,2,0,0,0,1,
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,
.db 0,1,2,0,1,2,1,0,1,2,1,2,1,1,0,0,
.db 0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0







;CLEARLEV: 
;.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
;.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
;.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
;.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
;.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
;.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
;.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
;.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0





PIC1: 
.db %00111100 
.db %01000010 
.db %10101001 
.db %10000001 
.db %10100101 
.db %10011001 
.db %10000001 
.db %01111110
.db %00111100 
.db %01000010 
.db %10101001 
.db %10000001 
.db %10100101 
.db %10011001 
.db %10000001 
.db %01111110  
.db %00111100 
.db %01000010 
.db %10101001 
.db %10000001 
.db %10100101 
.db %10011001 
.db %10000001 
.db %01111110  

PIC2: 
.db %00000000 
.db %00111000 
.db %01111100 
.db %01010100 
.db %01111100 
.db %01000100 
.db %00111000 
.db %00000000
.db %00000000 
.db %00111000 
.db %01111100 
.db %01010100 
.db %01111100 
.db %01000100 
.db %00111000 
.db %00000000
.db %00000000 
.db %00111000 
.db %01111100 
.db %01010100 
.db %01111100 
.db %01000100 
.db %00111000 
.db %00000000  

BOXPIC:                                            
	.db %01111110
	.db %10000001
	.db %10000001
	.db %10000001
	.db %10101011
	.db %11010101
	.db %11111111
	.db %01111110
	.db %01111110
	.db %10000001
	.db %11010101
	.db %11111111
	.db %11010101
	.db %10101011
	.db %10000001
	.db %01111110
	.db %01111110
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %01111110

NETPIC: 
.db %00111110 
.db %00101010 
.db %00111100 
.db %00011000 
.db %01000010 
.db %01100110 
.db %00011000 
.db %01100110
.db %00111111 
.db %00101011 
.db %00111110 
.db %00011100 
.db %01011011 
.db %01100111 
.db %00011110 
.db %01111111
.db %00111110 
.db %00101010 
.db %00111100 
.db %00011000 
.db %01000010 
.db %01100110 
.db %00011000 
.db %01100110 



CLRPIC: 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000 
.db %00000000  
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 


EXITPIC: 
.db %11111111 
.db %01101010 
.db %01001010 
.db %01100100 
.db %01001010 
.db %01101010 
.db %00000000 
.db %11111111
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 
.db %11111111 
.db %01101010 
.db %01001010 
.db %01100100 
.db %01001010 
.db %01101010 
.db %00000000 
.db %11111111 


TITLEPIC:
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00111000,%00000000,%00000000,%00000000,%00111000,%00000000,%00000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00111110,%00000000,%00000000,%00000000,%00011100,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000011,%10000000,%00000000,%00000000,%00000111,%00000000,%00000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00011000,%00000000,%00000000,%00000000,%00000001,%10000000,%00000000,%00000000,%00000011,%10000000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00001000,%00000000,%00000000,%00000000,%00000000,%11000000,%00000000,%00000000,%00000010,%11000000,%00000000,%01100000,%01110000,%00000000,%00000000,%00000000
  .db %00001100,%00000000,%00000000,%00000000,%00000000,%11000000,%00000000,%00000000,%00000010,%01100000,%00000000,%00100000,%11111000,%00000000,%00000000,%00000000
  .db %00000111,%11000000,%00000000,%00001000,%00000000,%01000011,%10000111,%11000000,%00000001,%00111000,%00000000,%01100000,%10101000,%00000000,%00000000,%00000000
  .db %00000111,%11110000,%00000000,%00000100,%00000000,%01000000,%11000000,%11000000,%00000001,%10011100,%00000000,%00100000,%11111000,%00000000,%00000000,%00000000
  .db %00000110,%01110001,%00000000,%00000110,%00000000,%01100000,%11110000,%01110000,%00110001,%10011100,%00000000,%01100000,%10001000,%00000000,%00000000,%00000000
  .db %00000110,%00110000,%10000000,%00000111,%00000000,%01100000,%01111000,%00110000,%00110001,%10001100,%00000000,%00100000,%11111000,%00000000,%00000000,%00000000
  .db %00000110,%00111000,%01100000,%00000011,%00000000,%01100000,%00101100,%00111100,%00110001,%11000110,%00000000,%01100000,%01110000,%00000000,%00000000,%00000000
  .db %00000111,%00011000,%01100000,%00000011,%00000000,%01110000,%00100100,%00111110,%00110001,%11000010,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00000111,%00011000,%01110001,%11110011,%00000000,%00110000,%00100110,%00010111,%00110000,%11000010,%00000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00000011,%00011000,%00110001,%11110011,%00000000,%00110000,%00100010,%00011011,%10110000,%11000011,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00000011,%00011000,%00110001,%10111011,%00000000,%00110000,%00111111,%00011001,%11110000,%11000011,%11000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00000011,%11111000,%00110001,%10111011,%00000000,%00110000,%00111011,%00011100,%01110000,%01000000,%11000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00000011,%11111000,%00110001,%10011011,%00000000,%00110000,%00100011,%00011100,%01110000,%01000000,%11000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00000011,%11100000,%00110001,%10011011,%00000000,%00110000,%00100011,%00001100,%01110000,%01000000,%11000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00000011,%00111000,%00110001,%10011011,%00000000,%00110000,%01100011,%00011100,%00110000,%01000000,%01000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00000011,%00011000,%00110001,%10011011,%00000000,%00110000,%11000011,%00011100,%00110000,%01000000,%01000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00000011,%00011000,%00110001,%10001011,%00000000,%01110011,%10000000,%00011000,%00110000,%01000000,%01000000,%01100000,%00000000,%00000011,%11110000,%00000000
  .db %00000011,%00001000,%00110001,%10001111,%00000000,%01100000,%00000000,%00011000,%00100000,%01000000,%01000000,%00100000,%00000000,%00000100,%00001000,%00000000
  .db %00000011,%00011000,%00110001,%10000000,%00000000,%01100000,%00000000,%00000000,%00110000,%01000000,%01000000,%01100000,%00000000,%00001001,%01000100,%00000000
  .db %00000011,%00011000,%00110001,%10000000,%00000000,%01100000,%00000000,%00000000,%00110000,%01000000,%01000000,%00100000,%00000000,%00001000,%00000100,%00000000
  .db %00000011,%00111000,%00000001,%10000000,%00000000,%01100000,%01111100,%00000000,%00110000,%01000000,%01000000,%01100000,%00000000,%00001000,%00000100,%00000000
  .db %00000011,%01111010,%00000001,%10000000,%00000000,%01011111,%11111111,%10000000,%00100000,%11000000,%01000000,%00100000,%00000000,%00001010,%00010100,%00000000
  .db %00000111,%11000001,%10000111,%10000000,%00000111,%11111000,%00000001,%11000000,%00100001,%11000000,%11000000,%01100000,%00000000,%00001010,%00010100,%00000000
  .db %00000110,%00000000,%11111111,%00000000,%00001111,%11000000,%00000000,%01100000,%01100001,%11000001,%11000000,%00100000,%00000000,%00001010,%00010100,%00000000
  .db %00000110,%00000000,%01111100,%00000000,%00011000,%00000000,%00000000,%00100000,%01000001,%10000001,%11000000,%01100000,%00000000,%00001001,%11100100,%00000000
  .db %00000100,%00000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00110000,%01000011,%10000011,%10000000,%00100000,%00000000,%00001000,%00000100,%00000000
  .db %00000100,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00001000,%11000111,%00111110,%00000000,%01100000,%00000000,%00000111,%11111000,%00000000
  .db %00000100,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%10000110,%01111100,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00001000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,%00001100,%11100000,%00000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00001000,%01111101,%11011100,%00000000,%11111101,%11110111,%11100110,%00000010,%00011111,%11000000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00100100,%01010000,%00000000,%01001000,%10010010,%10001010,%00000000,%00111100,%00000000,%00000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00111000,%01100000,%01000011,%01001000,%11100011,%10000110,%00000000,%00111000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00100100,%00100000,%00000010,%01001000,%10010010,%01001001,%00000000,%11100000,%00000000,%00000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%01111100,%01110000,%01000001,%10011101,%11011111,%11111111,%10000111,%10000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00100000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00001111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%10000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00011000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%11000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%01100000,%01000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%11110000,%01000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,%11111000,%01000000,%00100000,%00000000,%01000001,%11100000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%01000000,%01100000,%00000000,%11000001,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%01000000,%00100000,%00000000,%01000001,%00000000,%00000000
  .db %00010000,%10101001,%00010001,%10110000,%10011010,%10110100,%00000000,%00000000,%00000000,%00000000,%01000000,%01100000,%00000000,%01000001,%11100000,%00000000
  .db %00010001,%00101010,%10101010,%00100000,%10010010,%10100100,%00100000,%00000000,%00000000,%00000000,%01000000,%00100000,%00000000,%01000001,%00100000,%00000000
  .db %00010001,%00111010,%10101001,%00100000,%10010010,%10100100,%00000000,%00000000,%00000000,%00000000,%01000000,%01100000,%00000000,%01000001,%00100000,%00000000
  .db %00010001,%00111010,%10101000,%10110000,%10011010,%10110100,%00100000,%00000000,%00000000,%00000000,%01000000,%00100000,%00000000,%01001001,%11100000,%00000000
  .db %00010001,%00101010,%10101010,%10100000,%10010001,%00100100,%00000000,%00000000,%00000000,%00000000,%01000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%10101001,%00010001,%00110000,%11011001,%00110110,%00000000,%00000000,%00000000,%00000000,%01000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%01000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%01000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%01000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,%11111000,%01000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%11110000,%01000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%01100000,%01000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00011000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%11000000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00001111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%10000000,%00100000,%00000000,%00000000,%00000000,%00000000
  .db %00100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00100000,%01100000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000

;.db "HAPPY FACE!!!",0

;text2:
;.db "2nd Time",0

;title:		
;.db " BIN LAND 1.6 by Jirka",0

deathtext:
.db "YOU DIED!!",0

leveltext:
.db "LEVEL:",0

nexttext:
.db "STAGE CLEAR!!",0

lapitext:
.db "Congratulations!!",0

invert_text0:
.db "BIN LAND 1.6        ",0

invert_text1:
.db "jirka83@hotmail.com ",0




;PutSprite: 
    
;    push de    
;    ld hl,$fb80  
;    inc b         
;    ld de,$80   
;YCoord: 
;    add hl,de 
;    djnz YCoord 
;    add hl,bc   
;    pop de      
;    ld b,8        
;CopySprite: 
;    push bc          
;    ld a,(de)      
;    ld (hl),a       
;    inc de          
;    ld bc,16      
;    add hl,bc       
;    pop bc           
;    djnz CopySprite 
;    ret             




;from Matthew Fredrickson Contrast v1.1
Acon:
	ld a,($C008)	;this is loading the value of the current contrast settings into a register
					;so that you can manipulate it. If you just loaded a number in it, it would
					;destroy the current settings, so it usually is helpful keep the current 
					;value.
	inc a			;this adds 1 to the value at $C008 which, in turn, will darken the contrast
					;but can only do so after you reload it back into the memory address that 
					;controls the contrast
	ld ($C008),a	;this is where you put the new value back in the contrast memory address
	out (2),a		;this ouputs the new value in memory to port 2, which is the contrast
        jp ASK_FOR_KEY                ;this jumps you back to the original loop
	
Scon:
	ld a,1
	ld a,($C008)	;loads current contrast settings into a register
	sbc a,1			;subtracts 1 from a
	ld ($C008),a	;loads the new value back in
	out (2),a		;this outputs to the video port
        jp ASK_FOR_KEY                ;jumps to original loop




Pause:				
	call	GET_KEY			
	cp	K_ENTER			
	jp	z,PauseEnd
	cp  K_SECOND
	jp  z,PauseEnd
	jp Pause
PauseEnd:	
        ret				




   

;=========================================================================
; Sprite routines by David Phillips <david@acz.org>    http://www.acz.org/
;=========================================================================
; All sprites are 8x8 masked sprites
;
; 	PutSprite      -- black/white			      (sprite, mask)
; 	PutSpriteClip  -- black/white with clipping	  (sprite, mask)
; 	GraySprite     -- grayscale				      (dark, light, mask)
; 	GraySpriteClip -- grayscale with clipping	  (dark, light, mask)
;
; in:   hl = pointer to sprite, bc = x,y location
; out:  af, bc, de, hl, ix = trash
; size: 250 bytes
;=========================================================================

;=========================================================================
; in: hl = 8x8 masked sprite, bc = x,y location
;----------------------------grayscale-------------------------------------;

OpenGray:
	res 2,(iy+$23)
	ld hl,IntRoutine
	ld de,_user_int_ram+1
	ld bc,InterruptMemEnd-IntRoutine
	ldir
	ld a,(_user_int_ram+1)
	ld hl,_user_int_ram+($28*1)
	add a,(hl)
	ld hl,_user_int_ram+($28*2)
	add a,(hl)
	ld hl,_user_int_ram+($28*3)
	add a,(hl)
	ld hl,_user_int_ram+($28*4)
 	add a,(hl)
	ld hl,_user_int_ram+($28*5)
	add a,(hl)
	ld (_user_int_ram),a
	xor a
	ld (IntCounter), a
	ld (UserCounter), a
	ld de, IntData
	ld hl, SourceIntData
	ld bc, 2
	ldir
	set 2,(iy+$23)
	ret

CloseGray:
	res 2, (iy+$23)
	ld a, $3C
	out (0), a
	call ClearPage
	ret

ClearPage:
	ld hl, (Pages)
	call Clear1024
	ld hl, (Pages+2)
	call Clear1024
	ret
Clear1024:
	ld d, h
	ld e, l
	inc de
	ld (hl), 0
	ld bc, 1024
	ldir
	ret

IntRoutine:
	push af
	ld a,($C1B4)   ;_CXCURAPP
	cp $1D
	jr c,DownLeft_check
	cp $20
	jr nc,DownLeft_check
	jr DownLeft_OK
DownLeft_check:
	in a,($03)
	bit 3,a
	jr z,DownLeft_OK
	res 0,a
	out ($03),a
DownLeft_OK:
	push hl
	in a,(3)
	bit 1,a
	jr z,EndIntRoutine
	ld hl, UserCounter
	inc (hl)
	ld hl, IntData
	ld a,(IntCounter)
	cp 5
	jr z,DisplayLast
	cp 3
	jr c,DisplayBpl1
	jr DisplayBpl2

DisplayBpl1:
	inc a
	ld (IntCounter),a
	ld a, (hl)
	out (0),a
	jr EndIntRoutine

DisplayBpl2:
	inc a
	ld (IntCounter),a
	inc hl
	ld a, (hl)
	out (0),a
	jr EndIntRoutine

DisplayLast:
	ld a, (hl)
	out (0), a
	xor a
	ld (IntCounter),a

EndIntRoutine:
	ld a,(UserCounter)
	cp 41
	jr z,EndIntRoutine2
	pop hl
	pop af
	ret
EndIntRoutine2:
	xor a
	ld (UserCounter),a
	pop hl
	pop af
	ret

InterruptMemEnd:

;--------------------------------------------------------------------------;

GraySprite:
 push hl							; push sprite pointer
 pop ix								; pop in ix
 call FindAddress					; calc address and offset
GraySpriteE:
 push hl							; save address offset
 push ix							; save sprite pointer
 ld de,GrayDraw1					; draw to first gray buffer
 add hl,de							; add offset to buffer start
 ld a,16							; grayscale sprites are 16 bytes
 ld (RenderSpriteM),a				; adjust sprite load instruction
 call RenderSprite					; draw the sprite
 ld a,8								; second sprite is 8 bytes from mask
 ld (RenderSpriteM),a				; adjust sprite load instruction back
 pop ix								; restore sprite pointer
 pop hl								; restore address offset
 ld de,GrayDraw2					; now draw to second gray buffer
 add hl,de							; add offset to second buffer start
 ld de,$0008						; sprites are 8 bytes
 add ix,de							; advance sprite pointer

; in: hl = address in buffer, c = offset, ix = sprite
RenderSprite:
RenderSpriteCV =$+1
 ld b,8								; set row counter to 8 bytes
RenderSpriteL:
 push bc							; save row counter and sprite offset
 ld a,(ix+8)						; load mask for this row
RenderSpriteM =$-1
 cpl								; invert the mask
 ld b,a								; save inverted mask
 ld d,(ix)							; load sprite byte for this row
 inc ix								; advance sprite pointer
 ld a,c								; set shift counter to sprite offset
 ld c,$ff							; set all bits of right mask byte
 ld e,0								; clear right byte of sprite
 or a								; is the sprite aligned?
 jr z,RenderSpriteD					; then skip shifting it
RenderSpriteS:
 srl d								; shift left sprite byte
 rr e								; into the right sprite byte
 scf								; set carry
 rr b 								; shift left mask byte
 rr c								; into the right mask byte
 dec a								; decrease shift counter
 jr nz,RenderSpriteS				; loop until counter is 0
RenderSpriteD:
RenderSpriteCL =$
 ld a,b								; load the left sprite byte
 and (hl)							; and it with the screen
 or d								; or it with the mask
 ld (hl),a							; set screen memory to left byte
 inc hl								; increase screen pointer
RenderSpriteCR =$
 ld a,c								; load the right sprite byte
 and (hl)							; and it with the screen
 or e								; or it with the mask
 ld (hl),a							; set screen memory to left byte
 ld de,15							; next row is 15 bytes ahead
 add hl,de							; move screen pointer to next row
 pop bc								; restore loop counter and shift mask
 djnz RenderSpriteL					; loop for all bytes in sprite
 ret								; done drawing the sprite

; in: bc = x,y location
; out: hl = offset of byte, c = offset in video byte
FindAddress:
 ld a,c								; get the y coord
 add a,a							; multiply by 2
 add a,a							; again by 4
 ld l,a								; save as low byte
 ld h,0								; clear high byte
 add hl,hl							; multiply by 8
 add hl,hl							; and again by 16
 ld a,b								; now get the x coord
 and %11111000						; clear lower 3 bits
 rra								; divide by 2
 rra								; this time by 4
 rra								; and finally by 8
 or l								; combine with low byte
 ld l,a								; save it
 ld a,b								; get x coord again
 and %00000111						; clear all but last 3 bits
 ld c,a								; save sprite offset in c
 ret								; return to caller


IntCounter              equ _user_int_ram+InterruptMemEnd-IntRoutine+2
IntData                 equ _user_int_ram+InterruptMemEnd-IntRoutine+3
UserCounter             equ _user_int_ram+InterruptMemEnd-IntRoutine+5

SourceIntData:
.db PAGE1_BPL1, PAGE1_BPL2

Pages:
.dw $FC00, $F700


;-----Display HL Routine [By: SCaBBy]-----
DispA:
 ld l,a
 ld h,0
DispHL:					;dipslay 5 digits from hl
 xor a 
 ;ld de,-1
 ;ld (_curRow),de
 call 4A33h
 dec hl
 jp _vputs



EXIT:
;   call _clrLCD
;   ld hl,$0100
;   ld (_curRow),hl      
;   ld hl,kiitos0
;   call _puts  
 
;   ld hl,$0101
;   ld (_curRow),hl      
;   ld hl,kiitos1
;   call _puts  

;   ld hl,$0102
;   ld (_curRow),hl      
;   ld hl,kiitos2
;   call _puts  

;   ld hl,$0103
;   ld (_curRow),hl      
;   ld hl,kiitos3
;   call _puts  

;   ld hl,$0104
;   ld (_curRow),hl      
;   ld hl,kiitos4
;   call _puts  

;   ld hl,$0105
;   ld (_curRow),hl      
;   ld hl,kiitos5
;   call _puts  

;   ld hl,$0106
;   ld (_curRow),hl      
;   ld hl,kiitos6
;   call _puts  

;   ld hl,$0107
;   ld (_curRow),hl      
;   ld hl,kiitos7
;   call _puts  


  ;call Pause
   ;call _clrLCD 
   ;ld a,1
   ;ld (done),a  
	
   call CloseGray   
   ;call 409Ch            ;exit
   ret
   


;FINAL:
;        call CloseGray 
;  ret
 
.end                    

